Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/tablecmds.c,v
retrieving revision 1.1.1.3
retrieving revision 1.1.1.3.2.2
diff -c -r1.1.1.3 -r1.1.1.3.2.2
*** src/backend/commands/tablecmds.c	19 May 2009 06:59:32 -0000	1.1.1.3
--- src/backend/commands/tablecmds.c	26 May 2009 10:29:59 -0000	1.1.1.3.2.2
***************
*** 50,55 ****
--- 50,56 ----
  #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
  #include "nodes/parsenodes.h"
+ #include "nodes/pg_list.h"
  #include "optimizer/clauses.h"
  #include "parser/gramparse.h"
  #include "parser/parse_clause.h"
***************
*** 75,81 ****
--- 76,97 ----
  #include "utils/snapmgr.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
+ #include "tcop/tcopprot.h"
+ #include "utils/numeric.h"
  
+ /* For partitions */
+ #include "catalog/pg_partition.h"
+ #include "catalog/pg_operator.h"
+ #include "postgres.h"
+ #include "executor/spi.h"
+ #include "commands/trigger.h"
+ #include "utils/rel.h"
+ #include "commands/alter.h"
+ #include "tcop/utility.h"
+ 
+ extern Datum trigf(PG_FUNCTION_ARGS);
+ 
+ PG_FUNCTION_INFO_V1(trigf);
  
  /*
   * ON COMMIT action list
***************
*** 96,101 ****
--- 112,124 ----
  	SubTransactionId deleting_subid;
  } OnCommitItem;
  
+ 
+ typedef struct PartitionRowInfo
+ {
+     ItemPointerData tid;
+     Oid             partRelOid;
+ }PartitionRowInfo;
+ 
  static List *on_commits = NIL;
  
  
***************
*** 113,129 ****
   * a pass determined by subcommand type.
   */
  
! #define AT_PASS_DROP			0		/* DROP (all flavors) */
! #define AT_PASS_ALTER_TYPE		1		/* ALTER COLUMN TYPE */
! #define AT_PASS_OLD_INDEX		2		/* re-add existing indexes */
! #define AT_PASS_OLD_CONSTR		3		/* re-add existing constraints */
! #define AT_PASS_COL_ATTRS		4		/* set other column attributes */
  /* We could support a RENAME COLUMN pass here, but not currently used */
! #define AT_PASS_ADD_COL			5		/* ADD COLUMN */
! #define AT_PASS_ADD_INDEX		6		/* ADD indexes */
! #define AT_PASS_ADD_CONSTR		7		/* ADD constraints, defaults */
! #define AT_PASS_MISC			8		/* other stuff */
! #define AT_NUM_PASSES			9
  
  typedef struct AlteredTableInfo
  {
--- 136,161 ----
   * a pass determined by subcommand type.
   */
  
! #define AT_PASS_DROP					0		/* DROP (all flavors) */
! #define AT_PASS_ALTER_TYPE				1		/* ALTER COLUMN TYPE */
! #define AT_PASS_OLD_INDEX				2		/* re-add existing indexes */
! #define AT_PASS_OLD_CONSTR				3		/* re-add existing constraints */
! #define AT_PASS_COL_ATTRS				4		/* set other column attributes */
  /* We could support a RENAME COLUMN pass here, but not currently used */
! #define AT_PASS_ADD_COL					5		/* ADD COLUMN */
! #define AT_PASS_ADD_INDEX				6		/* ADD indexes */
! #define AT_PASS_ADD_CONSTR				7		/* ADD constraints, defaults */
! #define AT_PASS_ADD_PARTITION   		8		/* ADD partition to an existing table. */
! #define AT_PASS_DROP_PARTITION_NAME 	9   	/* DROP partition(By name) of an existing table */
! #define AT_PASS_DROP_PARTITION_RANGE 	10		/* DROP partition(By range) of an existing table */
! #define AT_PASS_UPDATE_PARTITION		11		/* UPDATE range partition. */
! #define AT_PASS_SPLIT_PARTITION			12		/* SPLIT range partition. */
! #define AT_PASS_MERGE_PARTITION			13		/* MERGE range partitions. */
! #define AT_PASS_UPDATE_HASH_PARTITION	14		/* UPDATE hash partitions. */
! #define AT_PASS_EXCHANGE_PARTITION		15		/* Exchange partition with a table.*/
! #define AT_PASS_RENAME_PARTITION		16		/* Rename partition. */
! #define AT_PASS_MISC					17		/* other stuff */
! #define AT_NUM_PASSES					18
  
  typedef struct AlteredTableInfo
  {
***************
*** 325,330 ****
--- 357,423 ----
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  							   ForkNumber forkNum, bool istemp);
+ static void CreatePartitions(CreateStmt *stmt, Oid parentRelOid, Oid *partitionRelOids);
+ static void MutateColumnRefs(Node *node, char *reference);
+ Oid OperatorGet(const char *operatorName,
+             Oid operatorNamespace,
+             Oid leftObjectId,
+             Oid rightObjectId,
+             bool *defined);
+ static char *ATExecAddPartition(AlteredTableInfo *tab, Relation rel,
+ 				Partition *part, bool dummyEntry); /* Adding partition to an existing table. */
+ static void ATExecDropPartitionByName(AlteredTableInfo *tab, Relation rel,
+ 				Partition *part); /* Deleting partition of an existing table by name. */
+ static void ATExecDropPartitionByRange(AlteredTableInfo *tab, Relation rel,
+ 				Partition *part); /* Deleting partition of an existing table by Range. */
+ static void ATExecUpdatePartition(AlteredTableInfo *tab, Relation rel,
+ 				Partition *part); /* Deleting partition of an existing table by Range. */
+ static void ATExecSplitPartition(AlteredTableInfo *tab, Relation rel,
+ 				SplitPartitionStmt *part); /* Splitting partition of an existing table. */
+ static void ATExecExchangePartition(AlteredTableInfo *tab, Relation rel,
+ 				ExchangePartitionStmt *part); /* Exchange a partition with an existing table. */
+ static void ATExecRenamePartition(AlteredTableInfo *tab, Relation rel,
+ 				RenamePartitionStmt *part); /* Rename a partition. */
+ static void ATExecMergePartition(AlteredTableInfo *tab, Relation rel,
+ 				MergePartitionStmt *part); /* Merge existing partitions. */
+ static void ATExecUpdateHashPartition(AlteredTableInfo *tab, Relation rel,
+ 				A_Const *part); /* Deleting partition of an existing table by Range. */
+ static Oid CreateInheritedTable(Oid relId, char *name, char *tablespace);
+ char* DisplayDatum(Datum datum, Oid type);
+ Datum GetDatum(Relation rel, Oid type, HeapTuple tuple, int column);
+ Oid get_relevant_partition(HeapTuple tuple, Relation rel);
+ Oid get_relevant_hash_partition(HeapTuple tuple, Relation rel);
+ bool IsPartition(Oid partOid);
+ bool IsOverflowPartition(Oid parentOid);
+ int GetPartitionType(Oid partOid);
+ int GetPartitionsCount(Oid parentOid);
+ int GetPartitionsCountAtt(Oid parentOid, Oid attNum);
+ List* GetPartitions(Oid parentOid);
+ void DeletePartitionEntries(Oid parentOid);
+ void DeletePartitionEntry(Oid partOid);
+ void RemoveOverflowPartition(Oid parentOid);
+ bool GotConstraints(Oid relId);
+ Node* makeColumnRef(char *colname, List *indirection, int location);
+ void AddLessThanCheckConstraint(Oid typ_oid, Datum max_datum, char *tableName, char *partitionColumn);
+ void AddGreaterThanCheckConstraint(Oid typ_oid, Datum max_datum, char *tableName, char *partitionColumn);
+ bool IsMinValue(Node *value);
+ bool IsMaxValue(Node *value);
+ int GetPartitionedTableType(Oid parentOid);
+ List *GetMaxValues(Oid parentOid);
+ List *GetMinValues(Oid parentOid);
+ List *GetPartitionAttributes(Oid parentOid);
+ List *GetPartitionAttributeTypes(Oid parentOid);
+ List *GetPartitionNames(Oid parentOid);
+ char *GetPartitionedTableFromOverflow(Oid parentOid);
+ bool GotTriggers(Oid relId);
+ void InsertTuple(HeapTuple newtuple, Oid targetId);
+ Oid  GetOverflowPartition(Relation rel);
+ void MoveValidRowsFromOverflow(Oid relId, Oid partId);
+ void RemoveConstraintsAttr(Oid relId, int attNumber);
+ Oid  GetOverflowIndexId(Oid relId);
+ void GetPartitionValues(Oid partOid, List **minValues, List **maxValues, List **attrs, int *nKeys);
+ Oid  GetProcId(Oid operOid);
+ 
  
  
  /* ----------------------------------------------------------------
***************
*** 685,690 ****
--- 778,806 ----
  			continue;
  		}
  
+ 		if(relOid != InvalidOid)
+ 		{
+ 			/* If partitioned-table is being dropped then delete entries from catalog table. */
+ 			if(GetPartitionsCount(relOid) > 0)
+ 			{
+ 				DeletePartitionEntries(relOid);
+ 				RemoveOverflowPartition(relOid);
+ 			}
+ 			/* Check if it is a partition. */
+ 			else if(IsPartition(relOid) == true)
+ 			{
+ 				if(GetPartitionType(relOid) == PART_RANGE)
+ 					elog(ERROR, "Can not drop partition. Use ALTER TABLE ... DROP PARTITION instead.");
+ 				else
+ 					elog(ERROR, "Can not drop partition. Use ALTER TABLE ... UPDATE PARTITIONS instead.");
+ 			}
+ 			/* Check if it an overflow partition. */
+ 			else if(IsOverflowPartition(relOid) == true)
+ 			{
+ 				elog(ERROR, "Can not drop overflow partition.");
+ 			}
+ 		}
+ 
  		/*
  		 * In DROP INDEX, attempt to acquire lock on the parent table before
  		 * locking the index.  index_drop() will need this anyway, and since
***************
*** 2200,2205 ****
--- 2316,2962 ----
  }
  
  /*
+  * GetPartitionedTableType: If it is hash/list/range. 
+  */
+ int GetPartitionedTableType(Oid parentOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitionType;
+ 
+ 	partitionType = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		/* Every partition will have only one entry for keyorder == 1 */	
+ 		if(pg_part->keyorder == 1)
+ 		{
+ 			partitionType = pg_part->parttype;
+ 			break;
+ 		}
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitionType;
+ } 
+ 
+ 
+ /*
+  * GetPartitionType: If it is hash/list/range. 
+  */
+ int GetPartitionType(Oid partOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitionType;
+ 
+ 	partitionType = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_partrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(partOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		/* Every partition will have only one entry for keyorder == 1 */	
+ 		if(pg_part->keyorder == 1)
+ 		{
+ 			partitionType = pg_part->parttype;
+ 			break;
+ 		}
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitionType;
+ } 
+ 
+ /*
+  * IsPartition : Check if given table is a partition. 
+  */
+ bool IsPartition(Oid partOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitions;
+ 
+ 	partitions = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_partrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(partOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		/* Every partition will have only one entry for keyorder == 1 */	
+ 		if(pg_part->keyorder == 1)
+ 			partitions++;
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitions > 0 ? true : false;
+ } 
+ 
+ 
+ /*
+  * GetPartitions : Check if given table is a partitioned table and return the list of
+  * partitions. 
+  */
+ List * 
+ GetPartitions(Oid parentOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	List		*partitions = NULL;
+ 	Relation	rel;
+ 	Oid			overflow;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		/* Every partition will have only one entry for keyorder == 1 */	
+ 		if(pg_part->keyorder == 1)
+ 		{
+ 			partitions = lappend_oid(partitions, pg_part->partrelid);
+ 		}
+ 	}
+ 
+ 	/* Also add overflow partition(if any) for this partitinoed table. */
+ 	rel = RelationIdGetRelation(parentOid);
+ 	overflow = GetOverflowPartition(rel);
+ 	
+ 	if(overflow != InvalidOid)
+ 	{
+ 		partitions = lappend_oid(partitions, overflow);
+ 	}
+ 	
+ 	RelationClose(rel);
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitions;
+ }
+ 
+ List *
+ GetMaxValues(Oid parentOid)
+ {
+     ScanKeyData skey;
+     Relation    pg_partrel;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+     List        *maxValues = NULL;
+ 	char		*max = "MAXVALUE";
+ 	Datum 		values[Natts_pg_partition];
+ 	char  		nulls [Natts_pg_partition];	
+ 	
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         /* Deform the tuple to find out if there are any MINVALUE/MAXVALUE present. */
+         heap_deformtuple(pg_parttup, pg_partrel->rd_att, values, nulls);
+ 
+ 		if(nulls[Anum_pg_partition_maxval-1] == 'n')
+ 		{
+ 			maxValues = lappend(maxValues, max);
+ 		}
+ 		else
+ 		{
+ 			maxValues = lappend(maxValues, DisplayDatum(GetDatum(pg_partrel, pg_part->keytype, pg_parttup, Anum_pg_partition_maxval), pg_part->keytype));
+ 		}
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return maxValues;
+ }
+ 
+ List *
+ GetMinValues(Oid parentOid)
+ {
+     ScanKeyData skey;
+     Relation    pg_partrel;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+     List        *minValues = NULL;
+ 	char		*min = "MINVALUE";
+ 	Datum 		values[Natts_pg_partition];
+ 	char  		nulls [Natts_pg_partition];	
+ 	
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+         /* Deform the tuple to find out if there are any MINVALUE/MAXVALUE present. */
+         heap_deformtuple(pg_parttup, pg_partrel->rd_att, values, nulls);
+ 
+ 		if(nulls[Anum_pg_partition_minval-1] == 'n')
+ 		{
+ 			minValues = lappend(minValues, min);
+ 		}
+ 		else
+ 		{
+ 			minValues = lappend(minValues, DisplayDatum(GetDatum(pg_partrel, pg_part->keytype, pg_parttup, Anum_pg_partition_minval), pg_part->keytype));
+ 		}
+ 	}
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return minValues;
+ }
+ 
+ List *
+ GetPartitionAttributes(Oid parentOid)
+ {
+     List    *partitionAttrs = NULL;
+ 	List	*partitionAttrNumbers = NULL;
+ 
+     ScanKeyData skey;
+     Relation    pg_partrel;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(!list_member_int(partitionAttrNumbers, pg_part->partkey))
+ 		{
+ 			partitionAttrNumbers = lappend_int(partitionAttrNumbers, pg_part->partkey);
+ 			partitionAttrs = lappend(partitionAttrs, get_attname(pg_part->partrelid, pg_part->partkey));
+ 		}
+     }
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitionAttrs;
+ }
+ 
+ List *
+ GetPartitionAttributeTypes(Oid parentOid)
+ {
+     List    *partitionAttrTypes = NULL;
+ 	List	*partitionAttrNumbers = NULL;
+ 
+     ScanKeyData skey;
+     Relation    pg_partrel;
+     SysScanDesc pg_partscan;
+     HeapTuple   pg_parttup;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+     {
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(!list_member_int(partitionAttrNumbers, pg_part->partkey))
+ 		{
+ 			partitionAttrNumbers = lappend_int(partitionAttrNumbers, pg_part->partkey);
+ 			partitionAttrTypes = lappend_int(partitionAttrTypes, pg_part->keytype);
+ 		}
+     }
+ 
+     systable_endscan(pg_partscan);
+     heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitionAttrTypes;
+ } 
+ 
+ List *
+ GetPartitionNames(Oid parentOid)
+ {
+ 	List		*partitions = NULL;
+ 	List		*partitionNames = NULL;
+ 	ListCell	*partition;
+ 
+ 	partitions = GetPartitions(parentOid);
+ 
+ 	foreach(partition, partitions)
+ 	{
+ 		if(IsOverflowPartition(lfirst_oid(partition))==false)
+ 		{
+ 			Relation rel = RelationIdGetRelation((Oid)lfirst_oid(partition));
+ 			partitionNames = lappend(partitionNames, RelationGetRelationName(rel));
+ 			RelationClose(rel);
+ 		}
+ 	}
+ 	
+ 	return partitionNames;
+ }
+ 
+ char *
+ GetPartitionedTableFromOverflow(Oid parentOid)
+ {
+     Relation    rel;
+     Oid         oid = 0;
+     int         length;
+     int         i;
+     int         offset = 0;
+ 	int			size;
+ 	char		*relName;
+ 
+     rel = RelationIdGetRelation(parentOid);
+ 
+ 	if(rel == NULL)
+ 		return NULL;
+ 
+     length = strlen(RelationGetRelationName(rel));
+ 
+     if(strncmp(RelationGetRelationName(rel), "of_", 3) == 0)
+     {
+         for(i=3; i<length; i++)
+         {
+             if(RelationGetRelationName(rel)[i] == '_')
+             {
+                 offset = i + 1;
+                 continue;
+             }
+         }
+ 
+ 		size = offset - 3;
+ 		relName = palloc(size);
+ 		strncpy(relName, RelationGetRelationName(rel)+3, size);
+ 		relName[size-1] = '\0';
+ 
+         sscanf(RelationGetRelationName(rel) + offset, "%u", &oid);
+         relation_close(rel, 0);
+ 
+         if(GetPartitionsCount(oid) > 0)
+ 		{
+ 			Relation tmpRel = RelationIdGetRelation(oid);
+ 		
+ 			if(tmpRel == NULL)
+ 				return NULL;
+ 
+ 			if(strncmp(RelationGetRelationName(tmpRel), relName, strlen(RelationGetRelationName(tmpRel))) == 0)
+ 			{
+         		relation_close(tmpRel, 0);
+ 			    return relName;
+ 			}
+ 		}
+     }
+ 
+     relation_close(rel, 0);
+     return NULL;
+ }
+ 
+ 
+ bool IsOverflowPartition(Oid parentOid)
+ {
+     Relation    rel;
+ 	Oid			oid = 0;
+ 	int			length;
+ 	int			i;
+ 	int			offset = 0;
+ 
+     rel = RelationIdGetRelation(parentOid);
+ 	length = strlen(RelationGetRelationName(rel));
+ 	
+ 	if(strncmp(RelationGetRelationName(rel), "of_", 3) == 0)
+ 	{
+ 		for(i=3; i<length; i++)
+ 		{
+ 			if(RelationGetRelationName(rel)[i] == '_')
+ 			{
+ 				offset = i + 1;
+ 				continue;
+ 			}			
+ 		}
+ 
+ 		sscanf(RelationGetRelationName(rel) + offset, "%u", &oid);
+ 		relation_close(rel, 0);
+ 
+ 		if(GetPartitionsCount(oid) > 0)
+ 			return true;
+ 		else
+ 			return false;
+ 	}
+ 	else
+ 	{
+ 		relation_close(rel, 0);
+ 		return false;
+ 	}
+ }
+ 
+ /*
+  * RemoveOverflowPartition : Remove the overflow partition for a given partitioned-table.
+  */
+ void RemoveOverflowPartition(Oid parentOid)
+ {
+ 	Relation 	rel;
+ 	StringInfo	query = makeStringInfo();
+ 	StringInfo	tableName = makeStringInfo();
+ 	List		*queryList;
+ 	Node		*parseTree;	
+ 
+ 	rel = RelationIdGetRelation(parentOid);
+ 	appendStringInfo(tableName, "of_%s_%u", RelationGetRelationName(rel), RelationGetRelid(rel));
+ 	relation_close(rel, 0);
+ 
+ 	if(RelnameGetRelid(tableName->data) != InvalidOid)
+ 	{
+ 		appendStringInfo(query, "DROP TABLE %s CASCADE;", tableName->data);
+ 
+ 		queryList = pg_parse_query(query->data);
+ 		parseTree = (Node *)lfirst(list_head(queryList));
+ 		RemoveRelations((DropStmt *)parseTree);
+ 	}
+ }
+ 
+ /*
+  * DeletePartitionEntry: Remove entries from partition catalog for a given relid. 
+  */
+ void DeletePartitionEntry(Oid partOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_partrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(partOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->parttype == PART_RANGE)
+ 		{
+ 	        simple_heap_delete(pg_partrel, &pg_parttup->t_self);
+     	    CommandCounterIncrement();
+ 		}
+ 		else
+ 		{
+ 			elog(ERROR, "Can not drop hash partition using ALTER TABLE ... DROP PARTITION. Use ALTER TABLE ... UPDATE PARTITIONS instead.");
+ 		}
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ } 
+ 
+ /*
+  * DeletePartitionEntries: Remove entries from partition catalog for a given relid. 
+  */
+ void DeletePartitionEntries(Oid parentOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         simple_heap_delete(pg_partrel, &pg_parttup->t_self);
+         CommandCounterIncrement();
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ } 
+ 
+ /*
+  * GetPartitionsCount: Check if given table is a partitioned table and return count of partitions. 
+  */
+ int GetPartitionsCount(Oid parentOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitions;
+ 
+ 	partitions = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		/* Every partition will have only one entry for keyorder == 1 */	
+ 		if(pg_part->keyorder == 1)
+ 			partitions++;
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitions;
+ } 
+ 
+ /*
+  * GetPartitionsCountAtt : Check if given table is a partitioned table and there 
+  * exists atleast one partition(s) for specified partition key column.
+  */
+ int GetPartitionsCountAtt(Oid parentOid, Oid attNum)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitions;
+ 
+ 	partitions = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->partkey == attNum)
+ 			partitions++;
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitions;
+ } 
+ 
+ 
+ /*
   * AlterTable
   *		Execute ALTER TABLE, which can be a list of subcommands
   *
***************
*** 2357,2362 ****
--- 3114,3123 ----
  	 */
  	switch (cmd->subtype)
  	{
+ 		case AT_AddPartition:	/* Add partition to an existing table. */
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_ADD_PARTITION;	
+ 			break;
  		case AT_AddColumn:		/* ADD COLUMN */
  			ATSimplePermissions(rel, false);
  			/* Performs own recursion */
***************
*** 2382,2404 ****
  			/* No command-specific prep needed */
  			pass = cmd->def ? AT_PASS_ADD_CONSTR : AT_PASS_DROP;
  			break;
! 		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
  			ATSimplePermissions(rel, false);
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse);
! 			/* No command-specific prep needed */
! 			pass = AT_PASS_DROP;
  			break;
! 		case AT_SetNotNull:		/* ALTER COLUMN SET NOT NULL */
  			ATSimplePermissions(rel, false);
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse);
! 			/* No command-specific prep needed */
! 			pass = AT_PASS_ADD_CONSTR;
  			break;
! 		case AT_SetStatistics:	/* ALTER COLUMN STATISTICS */
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse);
! 			/* Performs own permission checks */
! 			ATPrepSetStatistics(rel, cmd->name, cmd->def);
! 			pass = AT_PASS_COL_ATTRS;
  			break;
  		case AT_SetStorage:		/* ALTER COLUMN STORAGE */
  			ATSimplePermissions(rel, false);
--- 3143,3197 ----
  			/* No command-specific prep needed */
  			pass = cmd->def ? AT_PASS_ADD_CONSTR : AT_PASS_DROP;
  			break;
! 		case AT_DropPartitionByName: /* Drop partition by Name.*/
  			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_DROP_PARTITION_NAME;	
  			break;
! 		case AT_DropPartitionByRange: /* Drop partition by Range*/
  			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_DROP_PARTITION_RANGE;	
  			break;
! 		case AT_ExchangePartition: /* Drop partition by Range*/
! 			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_EXCHANGE_PARTITION;	
! 			break;
! 		case AT_RenamePartition: /* Drop partition by Range*/
! 			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_RENAME_PARTITION;	
! 			break;
! 		case AT_UpdatePartition: /* Update the range partition.*/
! 			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_UPDATE_PARTITION;
! 			break;
! 		case AT_UpdateHashPartition: /* Update the hash partition. */
! 			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_UPDATE_HASH_PARTITION;
! 			break;
! 		case AT_SplitPartition: /* Split partition. */
! 			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_SPLIT_PARTITION;
! 			break;
! 		case AT_MergePartition: /* Merge partitions. */
! 			ATSimplePermissions(rel, false);
! 			pass = AT_PASS_MERGE_PARTITION;
! 			break;
! 		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
! 			ATSimplePermissions(rel, false);
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse);
! 			/* No command-specific prep needed */
! 			pass = AT_PASS_DROP;
! 			break;
! 		case AT_SetNotNull:		/* ALTER COLUMN SET NOT NULL */
! 			ATSimplePermissions(rel, false);
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse);
! 			/* No command-specific prep needed */
! 			pass = AT_PASS_ADD_CONSTR;
! 			break;
! 		case AT_SetStatistics:	/* ALTER COLUMN STATISTICS */
! 			ATSimpleRecursion(wqueue, rel, cmd, recurse);
! 			/* Performs own permission checks */
! 			ATPrepSetStatistics(rel, cmd->name, cmd->def);
! 			pass = AT_PASS_COL_ATTRS;
  			break;
  		case AT_SetStorage:		/* ALTER COLUMN STORAGE */
  			ATSimplePermissions(rel, false);
***************
*** 2596,2601 ****
--- 3389,3397 ----
  {
  	switch (cmd->subtype)
  	{
+ 		case AT_AddPartition:   /* Add partition to an existing table. */
+ 			ATExecAddPartition(tab, rel, (Partition *)cmd->def, false);
+ 			break;
  		case AT_AddColumn:		/* ADD COLUMN */
  		case AT_AddColumnToView: /* add column via CREATE OR REPLACE VIEW */
  			ATExecAddColumn(tab, rel, (ColumnDef *) cmd->def, false);
